﻿<%@ Page Language="vb" AutoEventWireup="false" CodeBehind="igWebDataGrid.aspx.vb" Inherits="SandBoxWebApp.igWebDataGrid" %>

<%@ Register Assembly="Infragistics4.Web.v12.2, Version=12.2.20122.1007, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI.ListControls" TagPrefix="ig" %>
<%@ Register Assembly="Infragistics4.Web.v12.2, Version=12.2.20122.1007, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI.GridControls" TagPrefix="ig" %>

<%@ Register TagPrefix="ig" Namespace="Infragistics.Web.UI" Assembly="Infragistics4.Web.v12.2, Version=12.2.20122.1007, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" %>
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <script src="Scripts/jquery-2.1.0.js"></script>
    <style type="text/css">
        .error
        {
            background-color: #ccc;
            border: solid 1px #ccc;
            padding: 3px;
            white-space: nowrap;
            color: #c03;
            font-weight: bold;
            margin: 3px;
        }

    </style>
</head>
<body>
    <form id="form1" runat="server">
        <asp:ScriptManager ID="ScriptManager1" runat="server"></asp:ScriptManager>

        <asp:UpdatePanel ID="upWebDataGrid" runat="server" UpdateMode="Always">
            <ContentTemplate>

                <ig:WebDataGrid ID="WebDataGrid1" runat="server"
                    Height="350px" Width="800px"
                    AutoGenerateColumns="False"
                    DataSourceID="SqlDataSource1"
                    EnableAjax="false"
                    DataKeyFields="ID"
                    >

                    <Columns>
                        <ig:BoundDataField DataFieldName="ID" Key="ID" Hidden="true">
                            <Header Text="ID"></Header>
                        </ig:BoundDataField>
                        <ig:BoundDataField DataFieldName="Name" Key="Name">
                            <Header Text="Name"></Header>
                        </ig:BoundDataField>
                        <ig:BoundDataField DataFieldName="Address" Key="Address">
                            <Header Text="Address"></Header>
                        </ig:BoundDataField>
                        <ig:BoundDataField DataFieldName="City" Key="City">
                            <Header Text="City"></Header>
                        </ig:BoundDataField>
                        <ig:BoundDataField DataFieldName="State" Key="State">
                            <Header Text="State"></Header>
                        </ig:BoundDataField>
                        <ig:BoundDataField DataFieldName="Zip" Key="Zip">
                            <Header Text="Zip"></Header>
                        </ig:BoundDataField>
                        <ig:BoundDataField DataFieldName="OrderDate" Key="OrderDate">
                            <Header Text="OrderDate"></Header>
                        </ig:BoundDataField>

                    </Columns>

                    <EditorProviders>
                        <ig:DropDownProvider ID="StateProvider">
                            <EditorControl runat="server"
                                DropDownContainerMaxHeight="200px" EnableAnimations="False"
                                EnableDropDownAsChild="False" ClientIDMode="Predictable" TextField="State" ValueField="StateCode" DataSourceID="StatesDataSource">
                            </EditorControl>
                        </ig:DropDownProvider>
                        <ig:DatePickerProvider ID="WebDataGrid1_DatePickerProvider1">
                            <EditorControl ClientIDMode="Predictable"></EditorControl>
                        </ig:DatePickerProvider>
                        <ig:TextEditorProvider ID="WebDataGrid1_TextEditor">
                            <EditorControl ClientIDMode="Predictable"></EditorControl>
                        </ig:TextEditorProvider>
                    </EditorProviders>

                    <Behaviors>
                        <ig:EditingCore BatchUpdating="False">
                            
                            <EditingClientEvents
                                RowsDeleting="WebDataGrid1_Editing_RowsDeleting"
                                RowAdding="wdg_RowAdding"></EditingClientEvents>
                            <Behaviors>
                                <ig:RowAdding>

                                    <EditModeActions EnableOnKeyPress="True" EnableOnActive="true"></EditModeActions>
                                    <ColumnSettings>
                                        <ig:RowAddingColumnSetting EditorID="StateProvider" ColumnKey="State"></ig:RowAddingColumnSetting>
                                        <ig:RowAddingColumnSetting EditorID="WebDataGrid1_DatePickerProvider1" ColumnKey="OrderDate"></ig:RowAddingColumnSetting>
                                        <ig:RowAddingColumnSetting EditorID="WebDataGrid1_TextEditor" ValidatorID="rfvName" ColumnKey="Name"></ig:RowAddingColumnSetting>
                                    </ColumnSettings>

                                </ig:RowAdding>
                                <ig:RowDeleting></ig:RowDeleting>
                                <ig:CellEditing>
                                               
                                    <ColumnSettings>
                                        <ig:EditingColumnSetting EditorID="StateProvider" ColumnKey="State"></ig:EditingColumnSetting>
                                        <ig:EditingColumnSetting EditorID="WebDataGrid1_DatePickerProvider1" ColumnKey="OrderDate"></ig:EditingColumnSetting>
                                        <ig:EditingColumnSetting EditorID="WebDataGrid1_TextEditor" ValidatorID="rfvName" ColumnKey="Name"></ig:EditingColumnSetting>
                                    </ColumnSettings>

                                    <EditModeActions MouseClick="Double" EnableOnKeyPress="True"></EditModeActions>

                                </ig:CellEditing>
                            </Behaviors>
                        </ig:EditingCore>
                        <ig:Selection RowSelectType="Single" CellClickAction="Row"></ig:Selection>
                        <ig:RowSelectors></ig:RowSelectors>
                        <ig:Activation></ig:Activation>
                        <ig:ColumnResizing></ig:ColumnResizing>
                        <ig:Sorting SortingMode="Multi"></ig:Sorting>
                        <ig:Filtering FilterType="RowFilter"></ig:Filtering>
                        <ig:VirtualScrolling></ig:VirtualScrolling>
                    </Behaviors>

                </ig:WebDataGrid>

                <asp:RequiredFieldValidator ID="rfvName" runat="server" 
                    ControlToValidate="WebDataGrid1" 
                    CssClass="error"
                    ForeColor=""
                    Text="Name is required!">
                </asp:RequiredFieldValidator>

            </ContentTemplate>
        </asp:UpdatePanel>

<%--        <asp:Button ID="Button1" runat="server" Text="Full Postback" OnClientClick="refresh()" />--%>

        <asp:UpdatePanel runat="server" UpdateMode="Always">
            <ContentTemplate>
<%--                <asp:Button ID="Button2" runat="server" Text="Partial Postback" />--%>

                <asp:Label ID="Label1" runat="server" Text="Label" Width="100%"></asp:Label>
            </ContentTemplate>
        </asp:UpdatePanel>

        <asp:SqlDataSource runat="server" ID="SqlDataSource1" ConnectionString='<%$ ConnectionStrings:gwhConnectionString %>' 
            SelectCommand="SELECT [ModDate], [Name], [Address], [City], [State], [Zip], [OrderDate], [ID] FROM [Address] WHERE [FKID] = @FKID" 
            DeleteCommand="DELETE FROM [Address] WHERE [ID] = @ID" 
            InsertCommand="INSERT INTO [Address] ([FKID], [ModDate], [Name], [Address], [City], [State], [Zip], [OrderDate]) VALUES (@FKID, @ModDate, @Name, @Address, @City, @State, @Zip, @OrderDate)" 
            UpdateCommand="UPDATE [Address] SET [ModDate] = @ModDate, [Name] = @Name, [Address] = @Address, [City] = @City, [State] = @State, [Zip] = @Zip, [OrderDate] = @OrderDate WHERE [ID] = @ID">

            <SelectParameters>
                <asp:Parameter Name="FKID" Type="Int32" DefaultValue="2"></asp:Parameter>
            </SelectParameters>

            <DeleteParameters>
                <asp:Parameter Name="ID" Type="Int32"></asp:Parameter>
            </DeleteParameters>

            <InsertParameters>
                <asp:Parameter Name="FKID" Type="Int32"></asp:Parameter>
                <asp:Parameter Name="ModDate" Type="DateTime"></asp:Parameter>
                <asp:Parameter Name="Name" Type="String"></asp:Parameter>
                <asp:Parameter Name="Address" Type="String"></asp:Parameter>
                <asp:Parameter Name="City" Type="String"></asp:Parameter>
                <asp:Parameter Name="State" Type="String"></asp:Parameter>
                <asp:Parameter Name="Zip" Type="String"></asp:Parameter>
                <asp:Parameter Name="OrderDate" Type="DateTime"></asp:Parameter>
            </InsertParameters>

            <UpdateParameters>
                <asp:Parameter Name="ModDate" Type="DateTime"></asp:Parameter>
                <asp:Parameter Name="Name" Type="String"></asp:Parameter>
                <asp:Parameter Name="Address" Type="String"></asp:Parameter>
                <asp:Parameter Name="City" Type="String"></asp:Parameter>
                <asp:Parameter Name="State" Type="String"></asp:Parameter>
                <asp:Parameter Name="Zip" Type="String"></asp:Parameter>
                <asp:Parameter Name="ID" Type="Int32"></asp:Parameter>
                <asp:Parameter Name="OrderDate" Type="DateTime"></asp:Parameter>
            </UpdateParameters>
        </asp:SqlDataSource>

        <asp:SqlDataSource ID="StatesDataSource" runat="server" 
            ConnectionString='<%$ ConnectionStrings:gwhConnectionString2 %>' 
            SelectCommand="SELECT * FROM [states]">
        </asp:SqlDataSource>

    </form>


    <script type="text/javascript">

        function refresh() {
            __doPostBack("<%= WebDataGrid1.ClientID%>>", '');
        }

        function WebDataGrid1_Editing_RowsDeleting(sender, eventArgs) {
            var continueDelete = confirm("Are you sure you want to delete the selected row(s)?");
            if (!continueDelete)
                eventArgs.set_cancel(true);
        }

        //validates the entire row before adding
        function wdg_RowAdding(sender, eventArgs) {
            for (var i = 0; i < eventArgs.get_row().get_cellCount() ; i++) {
                var columnName = eventArgs.get_row().get_cell(i).get_column().get_headerText();
                switch (columnName.toLowerCase()) {
                    case "name":
                        if (eventArgs.get_row().get_cell(i).get_value() == null) {
                            eventArgs._cancel = true;
                            alert(columnName + " is required!");
                        }
                        break;
                    default:

                }
            }
        }

    </script>
</body>
</html>
